      SUBROUTINE mgfas(u,n)
      include 'PMparameters.h'
      INTEGER maxcyc,n,NPRE,NPOST,NG,MEMLEN,isw
      REAL u(n,n,n), ro
      DOUBLE PRECISION ALPHA,res1,res2
      DOUBLE PRECISION res,trerr,z,anorm2,Lam,reduc,rms
      PARAMETER (MEMLEN=17*2**(3*NG)/3+14*2**NG+8*NG)
c      PARAMETER (NG=8,MEMLEN=17*2**(3*NG)/3+14*2**NG+8*NG)
      PARAMETER (NPRE=10,NPOST=23,ALPHA=.1d0,TINY=1.e-15,hlim=1.e-10)
CU    USES anorm2,copy,interp,lop,maloc,matadd,matsub,relax2,rstrct,slvsm2
      INTEGER j,jcycle,jj,jm1,jpost,jpre,mem,nf,gridnum,nn,irho(NG),
     *irhs(NG),itau(NG),itemp(NG),iu(NG),maloc
      COMMON /memory/ z(MEMLEN),mem
      mem=0
      nn=n/2
      isw=1

      reduc=STDRED

c      pause
      gridnum=NG-1
      irho(gridnum)=maloc(nn**3)
      call rstrct(z(irho(gridnum)),u,nn)

1     if (nn.gt.NSMALL) then
        nn=nn/2
        gridnum=gridnum-1
        irho(gridnum)=maloc(nn**3)
        call rstrct(z(irho(gridnum)),z(irho(gridnum+1)),nn)
c        write(*,*) nn, gridnum
      goto 1
      endif


      nn=NSMALL
      iu(2)=maloc(nn**3)
      irhs(2)=maloc(nn**3)
      itau(2)=maloc(nn**3)
      itemp(2)=maloc(nn**3)


          call copy(z(itemp(2)),z(iu(2)),4)
        
          call lop(z(itau(2)),z(iu(2)),4)
          call matsub(z(itau(2)),z(irhs(2)),z(itau(2)),4)
          res1= rms(z(itau(2)),4)

c          write(*,*) res1, " I'm here"
c 3      call slvsm2mid(z(iu(2)),z(irhs(2)),4,reduc)

 3      do jpre=1,iter
c initial grid solution
              call relax2(z(iu(2)),z(irhs(2)),4,reduc,isw)

              if(reduc<0) then
                 reduc=-0.25*reduc
c                 write(*,*) res1,res2," bad relaxation in " ,4,reduc             
                 call copy(z(iu(2)),z(itemp(2)),4)
                 goto 3
              endif

         end do

          call lop(z(itau(2)),z(iu(2)),4)
          call matsub(z(itau(2)),z(irhs(2)),z(itau(2)),4)
          res2= rms(z(itau(2)),4)
          if(res2>res1) then
             reduc=reduc/2.d0
c             write(*,*) res1,res2," bad relaxation af " ,4,reduc             
             call copy(z(iu(2)),z(itemp(2)),4)
             goto 3
          endif





c     DONE INITIALIZING




      gridnum=NG
      do 16 j=3,gridnum
        nn=2*nn
        iu(j)=maloc(nn**3)
        irhs(j)=maloc(nn**3)
        itau(j)=maloc(nn**3)
        itemp(j)=maloc(nn**3)
c        ihold(j)=maloc(nn**3)
        call interp(z(iu(j)),z(iu(j-1)),nn)
        if (j.ne.gridnum) then
          call copy(z(irhs(j)),z(irho(j)),nn)
        else
          call copy(z(irhs(j)),u,nn)
        endif
        do 15 jcycle=1,maxcyc
            nf=nn
          do 12 jj=j,3,-1

          reduc=STDRED
          call copy(z(itemp(jj)),z(iu(jj)),nf)
        
          call lop(z(itau(jj)),z(iu(jj)),nf)
          call matsub(z(itau(jj)),z(irhs(jj)),z(itau(jj)),nf)
          res1= rms(z(itau(jj)),nf)


 9         do 11 jpre=1,NPRE


              call relax2(z(iu(jj)),z(irhs(jj)),nf,reduc,isw)
c
              if(reduc<0) then
                 reduc=-0.25*reduc
c                 write(*,*) res1,res2," bad prerelax " ,nf,reduc
                 call copy(z(iu(jj)),z(itemp(jj)),nf)
                 goto 9
              endif

c              if(jpre==1) write(*,*) "relaxing before ", nf,reduc

11        continue


          call lop(z(itau(jj)),z(iu(jj)),nf)
          call matsub(z(itau(jj)),z(irhs(jj)),z(itau(jj)),nf)
          res2= rms(z(itau(jj)),nf)

          if(res2>res1) then
             reduc=reduc/4.d0
c             write(*,*) res1,res2," bad prelax " ,nf,reduc             
             call copy(z(iu(jj)),z(itemp(jj)),nf)
             goto 9
          endif





          call lop(z(itemp(jj)),z(iu(jj)),nf)
          nf=nf/2
          jm1=jj-1
          call rstrct(z(itemp(jm1)),z(itemp(jj)),nf)
          call rstrct(z(iu(jm1)),z(iu(jj)),nf)

          call lop(z(itau(jm1)),z(iu(jm1)),nf)
          call matsub(z(itau(jm1)),z(itemp(jm1)),z(itau(jm1)),nf)
          if(jj.eq.j)trerr=ALPHA*anorm2(z(itau(jm1)),nf)

          call rstrct(z(irhs(jm1)),z(irhs(jj)),nf)
          call matadd(z(irhs(jm1)),z(itau(jm1)),z(irhs(jm1)),nf)
12          continue



          reduc = STDRED

          call copy(z(itemp(2)),z(iu(2)),4)

          call lop(z(itau(2)),z(iu(2)),4)
          call matsub(z(itau(2)),z(irhs(2)),z(itau(2)),4)
          res1= rms(z(itau(2)),4)

c 17       call slvsm2mid(z(iu(2)),z(irhs(2)),4,reduc)

 17       do jpre=1,iter
c coarsest grid solution
              call relax2(z(iu(2)),z(irhs(2)),4,reduc,isw)

              if(reduc<0) then
                 reduc=-0.025*reduc
c                 write(*,*) res1,res2," bad exact " ,4,reduc             
                 call copy(z(iu(2)),z(itemp(2)),4)

                 goto 17
              endif

           end do

          call lop(z(itau(2)),z(iu(2)),4)
          call matsub(z(itau(2)),z(irhs(2)),z(itau(2)),4)
          res2= rms(z(itau(2)),4)
          if(res2>res1) then
             reduc=reduc/2.d0
c             write(*,*) res1,res2," bad exact " ,reduc             
             call copy(z(iu(2)),z(itemp(2)),4)
             goto 17
          endif


          nf=NSMALL
          do 14 jj=3,j
          jm1=jj-1
          call rstrct(z(itemp(jm1)),z(iu(jj)),nf)
          call matsub(z(iu(jm1)),z(itemp(jm1)),z(itemp(jm1)),nf)
          nf=2*nf
        
          call interp(z(itau(jj)),z(itemp(jm1)),nf)
          call matadd(z(iu(jj)),z(itau(jj)),z(iu(jj)),nf)

          reduc=STDRED
          call copy(z(itemp(jj)),z(iu(jj)),nf)
        
          call lop(z(itau(jj)),z(iu(jj)),nf)
          call matsub(z(itau(jj)),z(irhs(jj)),z(itau(jj)),nf)
          res1= rms(z(itau(jj)),nf)


19        do 13 jpost=1,NPOST

              call relax2(z(iu(jj)),z(irhs(jj)),nf,reduc,isw)

              if(reduc<0) then
                 reduc=-0.025*reduc
c              write(*,*) res1,res2," bad relaxation at " ,nf,reduc             
              call copy(z(iu(jj)),z(itemp(jj)),nf)
               goto 19
              endif

c             if(jpost==1) write(*,*) "relaxing after", jj,reduc

13        continue

          call lop(z(itau(jj)),z(iu(jj)),nf)
          call matsub(z(itau(jj)),z(irhs(jj)),z(itau(jj)),nf)
          res2= rms(z(itau(jj)),nf)
          if(res2>res1) then
             reduc=reduc/4.d0
             call copy(z(iu(jj)),z(itemp(jj)),nf)
c             write(*,*) res1,res2," bad postlax " ,nf,jcycle,reduc
             goto 19
          endif

14          continue
            call lop(z(itemp(j)),z(iu(j)),nf)
            call matsub(z(itemp(j)),z(irhs(j)),z(itemp(j)),nf)
            res=anorm2(z(itemp(j)),nf)
            if((res.lt.trerr).and.(res.lt.(hlim/ro**2)))goto 2
15      continue
2       continue

c      write(*,*) 
c      call printrad(z(iu(j)),nf,j,'RAD')
c      if(j<gridnum) then
c      call printrad(z(irho(j)),nf,j,'RHO')
c      else
c      call printrad(u,nf,j,'RHO')
c      endif

16    continue
      call copy(u,z(iu(gridnum)),n)
      write(*,*) jcycle, res
      return
      END

c  Enter the current solution; 
c   output the operator L+N times the solution
      SUBROUTINE lop(out,u,n)
      include 'PMparameters.h'
      INTEGER n,npx,npy,npz,nmx,nmy,nmz
      REAL*8 out(n,n,n), u(n,n,n)
      INTEGER i,j,k,mi,f,A,B,C,A2,B2,C2
      DOUBLE PRECISION h,h2i,hL4i,upmxyz,Lam,part1,part2
      h=NGRID*1.d0/(n)
      h2i=1.d0/(h*h)
      hL4i=1.d0*Lam/(h**4)
!$OMP PARALLEL PRIVATE(j,i,npx,npy,npz,nmx,nmy,nmz,upmxyz,part1,part2)

!$OMP DO SCHEDULE(STATIC)
      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
             
             npx=mod(i,n)+1
             npy=mod(j,n)+1
             npz=mod(k,n)+1
             nmx=mod(i+n-2,n)+1
             nmy=mod(j+n-2,n)+1
             nmz=mod(k+n-2,n)+1

	  upmxyz=u(npx,j,k)+u(nmx,j,k)+u(i,npy,k)+u(i,nmy,k)+
     *u(i,j,nmz)+u(i,j,npz)     
       part1=(upmxyz-6.d0*u(i,j,k))
       part2= 24.d0*u(i,j,k)**2-
     *8.d0*upmxyz*u(i,j,k)+2.d0*(u(npx,j,k)+u(nmx,j,k))*(u(i,npy,k)+
     *u(i,nmy,k))+2.d0*(u(npx,j,k)+u(nmx,j,k))*(u(i,j,npz)+u(i,j,nmz))+
     *2.d0*(u(i,npy,k)+u(i,nmy,k))*(u(i,j,npz)+u(i,j,nmz))-
     *0.125d0*((u(npx,npy,k)+u(nmx,nmy,k))**2+(u(npx,j,npz)+
     *u(nmx,j,nmz))**2+(u(i,npy,npz)+u(i,nmy,nmz))**2)-
     *0.125d0*((u(npx,nmy,k)+u(nmx,npy,k))**2+(u(npx,j,nmz)+
     *u(nmx,j,npz))**2+(u(i,npy,nmz)+u(i,nmy,npz))**2)+
     *0.25d0*(u(npx,npy,k)+u(nmx,nmy,k))*(u(npx,nmy,k)+u(nmx,npy,k))+
     *0.25d0*(u(npx,j,npz)+u(nmx,j,nmz))*(u(npx,j,nmz)+u(nmx,j,npz))+
     *0.25d0*(u(i,npy,npz)+u(i,nmy,nmz))*(u(i,npy,nmz)+u(i,nmy,npz)) 
       out(i,j,k)=h2i*part1+hL4i*part2



11    continue
12    continue
13    continue
!$OMP end do NOWAIT
!$OMP END PARALLEL



      m=n/2
c      if(n>5) then
c      write(*,*) n, "^3 is the size; a typical value is ",h2i,out(m,m,m)
c      endif
      return
      END
		


      SUBROUTINE relax2(u,rhs,n,reduc,isw)
      include 'PMparameters.h'
c      include 'PMmesh.h'
      INTEGER n,npx,npy,npz,nmx,nmy,nmz
      REAL*8 rhs(n,n,n),u(n,n,n)
      double precision Lam,part1,part2,hL4i
      INTEGER i,ipass,isw,j,jsw,f,A,B,C,A2,B2,C2,half,test,sum
      DOUBLE PRECISION foh2,h,h2i,res,upmxyz,bot,pt2,pt1,fact,reduc
      h=NGRID*1.d0/(n)
      h2i=1.d0/(h*h)
      hL4i=1.d0*Lam/(h**4)
      foh2=-6.0d0*h2i
      half=n/2+1-n/4
     
       jsw=1
    
      sum=0
      do 14 ipass=1,4
        jsw=ipass-1

      do 13 k=1,n
        do 12 j=1,n
          do 11 i=1,n
      
     
             if(mod(i+j+k,4).eq.jsw) then

                
             npx=mod(i,n)+1
             npy=mod(j,n)+1
             npz=mod(k,n)+1
             nmx=mod(i+n-2,n)+1
             nmy=mod(j+n-2,n)+1
             nmz=mod(k+n-2,n)+1

	  upmxyz=u(npx,j,k)+u(nmx,j,k)+u(i,npy,k)+u(i,nmy,k)+
     *u(i,j,nmz)+u(i,j,npz)     
       part1=(upmxyz-6.d0*u(i,j,k))
       part2= 24.d0*u(i,j,k)**2-
     *8.d0*upmxyz*u(i,j,k)+2.d0*(u(npx,j,k)+u(nmx,j,k))*(u(i,npy,k)+
     *u(i,nmy,k))+2.d0*(u(npx,j,k)+u(nmx,j,k))*(u(i,j,npz)+u(i,j,nmz))+
     *2.d0*(u(i,npy,k)+u(i,nmy,k))*(u(i,j,npz)+u(i,j,nmz))-
     *0.125d0*((u(npx,npy,k)+u(nmx,nmy,k))**2+(u(npx,j,npz)+
     *u(nmx,j,nmz))**2+(u(i,npy,npz)+u(i,nmy,nmz))**2)-
     *0.125d0*((u(npx,nmy,k)+u(nmx,npy,k))**2+(u(npx,j,nmz)+
     *u(nmx,j,npz))**2+(u(i,npy,nmz)+u(i,nmy,npz))**2)+
     *0.25d0*(u(npx,npy,k)+u(nmx,nmy,k))*(u(npx,nmy,k)+u(nmx,npy,k))+
     *0.25d0*(u(npx,j,npz)+u(nmx,j,nmz))*(u(npx,j,nmz)+u(nmx,j,npz))+
     *0.25d0*(u(i,npy,npz)+u(i,nmy,nmz))*(u(i,npy,nmz)+u(i,nmy,npz)) 
       res=h2i*part1+hL4i*part2-rhs(i,j,k)
       fact=foh2+hL4i*(48.d0*u(i,j,k)-8.d0*upmxyz)

       if(abs(res/fact)>100000.000) then
          reduc=reduc*-1        
          goto 1
       endif

       u(i,j,k)=u(i,j,k)-reduc*res/fact


          endif
11        continue

12      continue
   
13      continue
        
14    continue
      
c      isw=mod(isw+1,4)
     
 1    return
      END

	
      FUNCTION maloc(len)
      include 'PMparameters.h'
C So far working for 3d; but only lightly changed from 2d
      INTEGER maloc,len,NG,MEMLEN
C      PARAMETER (NG=7,MEMLEN=13*2**(2*NG)/3+14*2**NG+8*NG-100/3)
      PARAMETER (MEMLEN=17*2**(3*NG)/3+14*2**NG+8*NG)
c      PARAMETER (NG=8,MEMLEN=17*2**(3*NG)/3+14*2**NG+8*NG)
      INTEGER mem
      DOUBLE PRECISION z
      COMMON /memory/ z(MEMLEN),mem
      if (mem+len+1.gt.MEMLEN) then
c         write(*,*)'insufficient memory in maloc'
         pause
      endif
      z(mem+1)=len
      maloc=mem+2
      mem=mem+len+1
      return
      END
