
C	     NROW = number of particles per row
C	     NGRID= number of cells on a side (normal grid)
      SUBROUTINE WRBOXES(SNAME,step)
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMmesh.h'
       REAL     INPUT,Box,fake
       INTEGER fakeint,step,IROW
       Character SNAME*5,Nam*13,fin*4,start1*3,Nam2*13,start2*3,N3*13
       Character  Hd*5,Tail*4,Nm*40
       Hd  ='PMcrs'
       Tail='.DAT'
       fin='.dat'
       start1='Bin'
       start2='ASC'

      OPEN(UNIT=15,FILE='cosmoparams.txt',status='unknown')


c     Old Model builder part
      READ  (15,*) fake,fake,fake, fakeint,Box,fake,fake,fakeint
      close(15)

       Nam = start1//SNAME//Char(step+48)//fin
       Nam2 = start2//SNAME//Char(step+48)//fin
       start1='HED'
       N3 = start1//SNAME//Char(step+48)//fin

       write(*,*) " this is my name, ", Nam,Box

 10   NBYTE = NRECL*4
      NACCES= NBYTE
      Nspecies = 0

         Nm = Hd//Char(ifile+48)//Tail

c         OPEN(UNIT=iun,FILE=Nm,ACCESS='DIRECT',
c     +	               STATUS='UNKNOWN',RECL=NACCES)
C...................................................................
C			Read data and open files
      OPEN(76,FILE=N3,status='unknown')
      OPEN(77,FILE=Nam,access='DIRECT',STATUS='UNKNOWN',RECL=NACCES)
      OPEN(78,File=Nam2,STATUS='UNKNOWN')
      CALL RDTAPE


      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates

      xmax =-1.e+9
      xmin = 1.e+9
      vmax =-1.e+9
      vmin = 1.e+9
      Icount =0


c      write (*,*) ' RDTAPE is done'
      WRITE (76,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
c      Box =INPUT(' Enter box size in Mpc/h   =')
C
      REWIND 76

c      DO IROW=1,NROW

c       CALL GETROW(IROW,1)
       WRITE(77,REC=IROW) RECDAT

       DO IN=1,NPAGE
	        X  =ScaleC* (XPAR(IN)-1.)
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
c           Icount =Icount +1
c           xmax =MAX(xmax,X,Y,Z)
c           xmin =MIN(xmin,X,Y,Z)
c           vmax =MAX(vmax,Vxs,Vys,Vzs)
c           vmin =MIN(vmin,Vxs,Vys,Vzs)
           write (78,200) X,Y,Z
 200       Format(3F8.3)     
           ENDDO
c      ENDDO

      close(76)
      close(77)
      close(78)

      RETURN
      END

