C _______________________ Run a series of 3-D SIMULATIONS
C
C                         Klypin, August 1993
c                      MOD BY: wyman, Sept. 2008
C
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMparams2.h'
      Character*5 SNAME
      DOUBLE PRECISION alpha, RC,time,D
      INTEGER step, NL
c      INCLUDE 'PMmesh.h'
      
C		   NROW = number of particles in 1 dimension
C		   NGRID= number of cells        in 1 dimension
C		   Npage =  number of particles per page = NROW**2
C
C     alpha = alpha of modification (0.5 for DGP)
C     RC = r_c in code units, ie
c     intrinsic gravity scale in code units; RC=85 (r_c/100Mpc)
C     NL = 1 --> include nonlinearities on RHS of poisson
C     NL = 0 --> don't include nonlinearites on RHS of poisson


      alpha = 0.0
      RC = 1000
      NL = 1
      D = 5

      DO step=1,1
      Call GENMOD(step)
      Call START
c      Call EVOLVE(1.0,alpha,RC,NL)
c      SNAME = 'al0z1'
c      Call WRPOWER(SNAME)
c      Call EVOLVE(0.5,alpha,RC,NL)
c      SNAME = 'z0hlf'
c      CALL WRPOWER(SNAME)
      CALL EVOLVE(0.0,alpha,RC,NL,D)
      SNAME = 'al0z0'
      Call PRINTPHI(1)
      Call WRPOWER(SNAME,50)
c      CALL WRBOXES(SNAME,step)
      end do

      STOP
      END

	  
