#!/bin/bash

usage(){
	echo "Usage: $0 {-c prefix} "
	exit 1
}


copyFile(){
    names=( "AlphaHalf" "AlphaZero" )
    vals=( 500 1000 1500 3000 )
    sizes=(64 128 256 400)
   
    for ((i=0; i<=3; i++))
    do
	for((k=0;k<=3;k++))
	do
       	cp ./${names[1]}/rc${vals[$i]}/${sizes[k]}Mpc/Specal0z0.dat ./$1Spec${sizes[k]}Mpc_rc${vals[$i]}.txt
	done
    done
}

while getopts c:t option
do
    case "${option}"
        in
        c) copyFile ${OPTARG};;
        \?) usage
            exit 1;;
    esac
done
